summaryrefslogtreecommitdiffstats
path: root/test/integration/test-apt-update-reporting
diff options
context:
space:
mode:
Diffstat (limited to 'test/integration/test-apt-update-reporting')
-rwxr-xr-xtest/integration/test-apt-update-reporting35
1 files changed, 35 insertions, 0 deletions
diff --git a/test/integration/test-apt-update-reporting b/test/integration/test-apt-update-reporting
new file mode 100755
index 0000000..cecf23a
--- /dev/null
+++ b/test/integration/test-apt-update-reporting
@@ -0,0 +1,35 @@
+#!/bin/sh
+set -e
+
+TESTDIR="$(readlink -f "$(dirname "$0")")"
+. "$TESTDIR/framework"
+setupenvironment
+configarchitecture 'amd64'
+
+for i in $(seq 100); do
+ insertpackage 'unstable' "foo-$i" 'all' '1.0'
+ insertsource 'unstable' "foo-$i" 'all' '1.0'
+done
+
+setupaptarchive --no-update
+changetowebserver
+
+aptget update -o Debug::Acquire::Progress=1 2>progress.log >ignore.out
+
+has_progress() {
+ prev_percent=0.0
+ while read line; do
+ percent="$(echo "$line"|cut -b2-6)"
+ # need to cut the decimal point and digits because sh can not do
+ # float compare
+ if [ "${percent%%.*}" -lt "${prev_percent%%.*}" ]; then
+ cat progress.log
+ return 1
+ fi
+ prev_percent="$percent"
+ done < progress.log
+ return 0
+}
+
+msgtest "Testing that progress does not go backward"
+testsuccess --nomsg has_progress